using System;

namespace _06_AccessModifiersAndValidation
{
    class Person
    {
        private string firstName;
        public string FirstName
        {
            get { return firstName; }
            set
            {
                if(value.Length < 3)
                {
                    throw new ArgumentException("First Name cannot be shorter than 3 characters.");
                }
                firstName = value;
                
            }
        }
        
        private string lastName;
        public string LastName
        {
            get { return lastName; }
            set
            {
                if(value.Length < 3)
                {
                    throw new ArgumentException("Last Name cannot be shorter than 3 characters.");
                }
                lastName = value;
            }
        }

        private int age;
        public int Age
        {
            get { return age; }
            set
            {
                if(value < 1)
                {
                    throw new ArgumentException("Age cannot be 0 or negative.");
                }
                age = value;
            }
        }
        
        private decimal salary;
        public decimal Salary
        {
            get { return salary; }
            set
            {
                if(value < 530.0M)
                {
                    throw new ArgumentException("Salary cannot be less than the minimum wage (530.0)");
                }
                salary = value;
            }
        }
        
        public Person(string name, string lname, int age, decimal salary)
        {
            FirstName = name;
            LastName = lname;
            Age = age;
            Salary = salary;
        }
    }
}
